
#include "stdafx.h"
#include "util.h"
#include "ArcManDLL.h"

CArcManDLL::CArcManDLL()
{
	m_bAble = false;
	VerFunc = NULL;
	CmdFunc = NULL;
	ChkFunc = NULL;
}

CArcManDLL::~CArcManDLL()
{
	if( m_bAble )
		FreeLibrary(hDLL);
}

void CArcManDLL::VersionString( CKString& VerStr )
{
	CKString Name;
	m_ModuleName.GetFileName( Name );

	char str[255];
	Name.Buf(str,12);
	memset( str+strlen(str),' ',13-strlen(str) );
	str[13]='\0';

	VerStr = str;
	if( !m_bAble )				VerStr += "Not Installed";
	else if( VerFunc==NULL )	VerStr += "Invalid";
	else
	{
		WORD ver = VerFunc();
		sprintf(str,"Ver %d.%02d",ver/100,ver%100);
		VerStr += str;
	}
}

bool CArcManDLL::LoadFromNST( const char* filename )
{
	FILE* fp = fopen(filename,"rt");
	if( fp==NULL )return false;

	char tmp[1024];
	CKString str[15];
	for( int i=1; i!=15; i++ )
	{
		if( NULL==fgets(tmp,sizeof(tmp),fp) )
		{
			fclose(fp);
			return false;
		}
		str[i]=tmp;
		str[i].RemoveWhiteSpace();
	}

	fclose(fp);

	Init( str[1] , str[3] , str[2] , str[9] );

	char a[1024],b[1024],c[1024];
	if( *((const char*)str[4])!='\0' )
	{
		sscanf(str[4],"%[^ ,] , %[^ ,] , %[^\0]",a,b,c);
		AddCompressCmd(a,b,c);
	}
	if( *((const char*)str[5])!='\0' )
	{
		sscanf(str[5],"%[^ ,] , %[^ ,] , %[^\0]",a,b,c);
		AddCompressCmd(a,b,c);
	}
	if( *((const char*)str[6])!='\0' )
	{
		sscanf(str[6],"%[^ ,] , %[^ ,] , %[^\0]",a,b,c);
		AddCompressCmd(a,b,c);
	}
	if( *((const char*)str[7])!='\0' )
		SetSFXCmd( str[7] );

	if( *((const char*)str[8])!='\0' )
		SetMeltCmd( str[8] );

	return true;
}

void CArcManDLL::Init(LPCSTR Dll,LPCTSTR VerF,LPCTSTR CmdF,LPCTSTR ChkF)
{
	m_ModuleName = Dll;
	hDLL = LoadLibrary(Dll);
	if( hDLL==NULL )return;
	m_bAble = true;
	if( VerF != NULL )	VerFunc =  (DLL_VERSION)GetProcAddress(hDLL,VerF);
	if( CmdF != NULL )	CmdFunc =  (DLL_CMD)GetProcAddress(hDLL,CmdF);
	if( ChkF != NULL )	ChkFunc =  (DLL_CHECK)GetProcAddress(hDLL,ChkF);
}

void CArcManDLL::AddCompressCmd( const char* pType,const char* pExt,const char* pCmd )
{
	if( m_nType>=3 )return;

	m_Types[m_nType]=pType;
	m_Exts[m_nType]=pExt;
	m_CmpCmds[m_nType]=pCmd;
	m_nType++;
}

bool CArcManDLL::CanMelt( const char* fname )
{
	if( !m_bAble || m_MeltCmd.Length==0 || ChkFunc==NULL )	return false;
	return ( FALSE!=ChkFunc(fname,0) );
}

bool CArcManDLL::CanCompress( CKString& Type )
{
	if( !m_bAble )	return false;
//	return ( m_Types[0]==Type || m_Types[1]==Type || m_Types[2]==Type );
	for( int i=0; i!=m_nType; i++ )
	{
		const char* c = m_Types[i];
		if( *c=='$' || *c=='#' || *c=='&' || *c=='%' || *c=='*' )c++;
		if( Type==c )	return true;
	}
	return false;
}

bool CArcManDLL::CanSFX()
{
	if( !m_bAble )	return false;
	for(int t=0;t!=m_nType;t++)
	{
		const char* c = m_Types[t];
		if( *c=='$' || *c=='#' || *c=='&' || *c=='%' || *c=='*' )c++;
		if( 0==strcmp(c,"SFX") )break;
	}
	if( t==m_nType )
		return ( m_SfxCmd.Length()!=0 );
	return true;
}

bool CArcManDLL::ExecCommand( const char* cmd , const char* current/*=NULL*/ )
{
	if( !m_bAble )	return false;
	if( current != NULL )
		SetCurrentDirectory(current);
	int ans = CmdFunc( NULL,cmd,NULL,0 );

	// Jg߂ĂBi폜ł悤Ɂj
	char str[MAX_PATH];
	GetSpecialDir( str,CSIDL_MODULE,NULL );
	SetCurrentDirectory(str);
	// 0x8000ȂG[ł͂Ȃ[U[ɂXLbvȂǂ̂͂BƂB
	return (0x8000>ans);
}

bool CArcManDLL::Compress( CKString& Type,CFileList& Files,CKString& Path,CKString* pResult )
{
	if( !m_bAble )	return false;
	///////////// k` ///////////////
	for(int t=0;t!=m_nType;t++)
	{
		const char* c = m_Types[t];
		if( *c=='$' || *c=='#' || *c=='&' || *c=='%' || *c=='*' )c++;
		if( Type==c )	break;
	}
	if( t==m_nType )	return false;

	CKString ArcPath,FileList,Tmp,FirstFile,ArcDir;
	CKString Dir,Name,Ext;
	///////////// ɖtpXōBpResultɏóB""ň͂ArcPath ///////////
	Files.GetAt(0).SplitPath( Dir,Name,Ext );
	Tmp = Path;		Tmp += Name;	Tmp += ".";		Tmp += m_Exts[t];
	if( pResult!=NULL )	*pResult = Tmp;
	Tmp.DoubleQuote( ArcPath );
	// ɃpX
	Path.DoubleQuote( ArcDir );

	///////////// kt@C̗ /////////////////////
	bool bTrueWild = (*((const char*)Type)=='*');

	for( int i=0; i!=Files.GetLength(); i++ )
	{
		Files.GetAt(i).GetFileName( Name );
		if( i==0 )// ڃt@C( FfBNgłłCɂȂ )
			Name.DoubleQuote(FirstFile);
		if( PathIsDirectory( Files.GetAt(i) ) )
			Name += bTrueWild?"\\*":"\\*.*";
		Name.DoubleQuote( Name );
		FileList += Name;
		FileList += " ";
	}
	////////////// R}h𑗂 ///////////////////////////////
	//  $  (%s , %s) = ( Files[0] , ArcName  )
	//  #  (%s , %s) = ( Files[0] , ArcDir   )
	//  &  (%s , %s) = ( ArcName  , Files[0] )
	//  %  (%s , %s) = ( ArcDir   , Files[0] )
	// Def (%s , %s) = ( ArcName  , Files... )

	char *cmd = new char[ m_CmpCmds[t].Length() + ArcPath.Length() + FileList.Length() + 20 ];
	bool ans;
	switch( *((const char*)m_Types[t]) )
	{
	case '$':
		sprintf( cmd,m_CmpCmds[t],(const char*)FirstFile,(const char*)ArcPath );
		break;
	case '#':
		sprintf( cmd,m_CmpCmds[t],(const char*)FirstFile,(const char*)ArcDir );
		break;
	case '&':
		sprintf( cmd,m_CmpCmds[t],(const char*)ArcPath,(const char*)FirstFile );
		break;
	case '%':
		sprintf( cmd,m_CmpCmds[t],(const char*)ArcDir,(const char*)FirstFile );
		break;
	default:
		sprintf( cmd,m_CmpCmds[t],(const char*)ArcPath,(const char*)FileList );
		break;
	}

	ans = ExecCommand( cmd,Dir );
	delete [] cmd;
	return ans;
}

bool CArcManDLL::SFX( CKString& Type,CFileList& Files,CKString& Path )
{
	if( !m_bAble )	return false;

	// ʂ̈kR}ĥexeo͂镨΂B //////////
	for(int t=0;t!=m_nType;t++)
	{
		const char* p = m_Types[t];
		if( *p=='$' || *p=='#' || *p=='&' || *p=='%' || *p=='*' )p++;
		if( 0==strcmp(p,"SFX") )break;
	}
	if( t!=m_nType )
		return Compress( m_Types[t],Files,Path );

	///////////// Ƃ肠windows\tempɈkASFXɖ擾 /////////////////////
	char tmppath[MAX_PATH];
	GetSpecialDir(tmppath,CSIDL_TEMP);
	CKString ArcPath,TmpPath = tmppath;
	TmpPath += "\\";

	if( !Compress(Type,Files,TmpPath,&ArcPath) )
		return false;

	CKString Dir,Name,Ext;
	ArcPath.SplitPath( Dir,Name,Ext );
	Name += ".exe";

	////////////// ȉ𓀌`ɃRo[g //////////////////////////////////
	CKString SfxPath = TmpPath;	SfxPath += Name;
	CKString LastPath = Path;	LastPath += Name;
	CKString DQArc;
	ArcPath.DoubleQuote( DQArc );

	char* cmd = new char[ m_SfxCmd.Length() + DQArc.Length() + 20 ];
	sprintf( cmd,m_SfxCmd,(const char*)DQArc,"" );
	bool ans = ExecCommand( cmd,TmpPath );
	delete [] cmd;

	/////////////// w肳ꂽꏊֈړ /////////////////////////////////////
	DeleteFile(LastPath);
	DeleteFile(ArcPath);
	MoveFile(SfxPath,LastPath);
	return ans;
}

bool CArcManDLL::Melt( CKString& File,CKString* pPath,bool bMDir,bool bNoDDir )
{
	if( !m_bAble )	return false;

	CKString Meltout,MadeDirName,Tmp,SetteiMD=*pPath;

	if( bMDir )
	{
		File.SplitPath( Tmp,MadeDirName,Tmp );
		*pPath += MadeDirName;
		*pPath += "\\";
	}
	Meltout = *pPath;
	CreateDir( Meltout );

	CKString ArcPath;	File.DoubleQuote( ArcPath );

	char* cmd = new char[ m_MeltCmd.Length() + ArcPath.Length() + 20 ];
	sprintf( cmd,m_MeltCmd,(const char*)ArcPath,"" );
	bool ans = ExecCommand( cmd,Meltout );
	delete [] cmd;

	if( !ans )
		return false;

	//ŎbdtH_h~@\iGȃR[hȂ̂ł܂茩Ȃłˁj
	if( bMDir && bNoDDir )
	{
		WIN32_FIND_DATA Dt;
		Tmp = Meltout;	Tmp += "*.*";
		HANDLE h = FindFirstFile(Tmp,&Dt);

		while( 0==strcmp(Dt.cFileName,".") || 0==strcmp(Dt.cFileName,"..") )
			{	if( !FindNextFile(h,&Dt) )	break;	}
		if( Dt.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
		{
			if( MadeDirName.Compare(CKString(Dt.cFileName)) )
			{
				if( !FindNextFile(h,&Dt) )
				{
					Tmp = Meltout;			Tmp += MadeDirName;
					CKString RF = SetteiMD;	RF += MadeDirName;
					CKString TTmmpp = RF;	TTmmpp += "-n1o7a8h1t1m6p";
					MoveFile( Tmp,TTmmpp );	RemoveDirectory( RF );	MoveFile( TTmmpp,RF );
				}
			}
		}
		FindClose( h );
	}

	return true;
}
