
#include "stdafx.h"
#include "KString.h"

CKString::CKString()
{
	alen=MAX_PATH;
	buf = new char[alen];
	buf[0]='\0';
}

CKString::CKString(CKString& other)
{
	alen=other.alen;
	buf = new char[alen];
	strcpy(buf,other.buf);
}

CKString::CKString(const char* s)
{
	alen=strlen(s)+1;
	buf = new char[alen];
	strcpy(buf,s);
}

CKString::~CKString()
{
	delete [] buf;
}

CKString& CKString::operator = (CKString& s)
{
	int l=strlen(s.buf);
	if( l+1>alen )
	{
		delete [] buf;
		alen = l+1;
		buf = new char[alen];
	}
	strcpy( buf,s.buf );

	return *this;
}

CKString& CKString::operator = (const char* s)
{
	int l=strlen(s);
	if( l+1>alen )
	{
		delete [] buf;
		alen = l+1;
		buf = new char[alen];
	}
	strcpy( buf,s );

	return *this;
}

void CKString::operator += (const char* s)
{
	int len=strlen(buf);
	int l=strlen(s);
	if( len+l+2>alen )
	{
		alen = len+l+2;
		char* p = new char[alen];
		strcpy(p,buf);
		delete [] buf;
		buf = p;
	}
	strcat( buf,s );
}

void CKString::Buf( char* s,int l )
{
	if( l==-1 || l>=Length() )
		strcpy(s,buf);
	else
	{
		memcpy(s,buf,l);
		s[l]='\0';
	}
}

void CKString::DoubleQuote( CKString& Str )
{
	const char* p = buf;
	while( *p!='\0' )
	{
		if( *p==' ' )break;
		p++;
	}
	if( *p=='\0' )
	{
		Str = buf;
		return;
	}
	CKString Tmp = "\"";
	Tmp += buf;
	Tmp +="\"";
	Str = Tmp;

/*
	char* tmp = new char[Length()+3];
	Buf(tmp);
	PathQuoteSpaces(tmp);
	Str=tmp;
	delete [] tmp;
*/
}

static int strlastyen( const char *p )
{
	int l=strlen(p);
	int a=-1;
	for( int i=0; i<l; i++ )
	{
		if( p[i]=='\\' || p[i]=='/' )
			a=i;
		if( IsDBCSLeadByte(p[i]) )
			i++;
	}
	return a;
}

static int strlastchar( const char *p,char c )
{
	int l=strlen(p);
	int a=-1;
	for( int i=0; i<l; i++ )
	{
		if( p[i]==c )
			a=i;
		if( IsDBCSLeadByte(p[i]) )
			i++;
	}
	return a;
}

void CKString::GetFileName( CKString& Name )
{
	int s=strlastyen(buf);
	Name=&buf[s+1];
}

void CKString::SplitPath( CKString& Dir,CKString& Name,CKString& Ext )
{
	char t;
	int e=strlastchar(buf,'.');
	int s=strlastyen(buf);
	if( s==-1 )	s=0;
	if( e==-1 )	e=Length();
	
	t=buf[s] , buf[s]='\0' , Dir=buf , buf[s]=t;
	t=buf[e] , buf[e]='\0' , Name=&buf[s+1] , buf[e]=t;
	Ext = (e!=-1)?&buf[e+1]:"";
}

void CKString::RemoveWhiteSpace()
{
	char* p = buf;
	while( *p!='\0' )
	{
		if( *p!=' ' && *p!='\n' && *p!='\t')
			break;
		p++;
	}
	*this = p;

	p = buf + strlen(buf);
	p=CharPrev(buf,p);
	while( p>=buf )
	{
		if( *p!=' ' && *p!='\n' && *p!='\t')
			break;
		p=CharPrev(buf,p);
	}
	*CharNext(p)='\0';
}
